# fonctions pour transformer les dates
# format date postgres: dd-mm-yyyy

proc init_jour {} {
    return [exec date +%d-%m-%Y]
}

proc ret_mois {date} {
    return [lindex [split $date -] 1]
}
proc ret_an {date} {
    return [lindex [split $date -] 2]
}

proc decoupe_date {laq} {
    global date_comptable jour_comptable mois_comptable annee_comptable

    if {$date_comptable($laq) == ""} {
	set jour_comptable($laq) 0
	set mois_comptable($laq) 0
	set annee_comptable($laq) 0
    } else {	
	set date_l [split $date_comptable($laq) -]
	# format jour-mois-anne
	set jour [lindex $date_l 0]
	set mois [lindex $date_l 1]
	set annee_comptable($laq) [lindex $date_l 2]
	# probleme avec l'octal
	if {[string index $jour 0] == "0"} {
	    set jour_comptable($laq) [string index $jour 1]
	} else {set jour_comptable($laq) $jour}
	if {[string index $mois 0] == "0"} {
	    set mois_comptable($laq) [string index $mois 1]
	} else {set mois_comptable($laq) $mois}
    }
}
proc recolle_date {laq} {
    global jour_comptable mois_comptable annee_comptable mois_jour

    if {$jour_comptable($laq) == 0 || $mois_comptable($laq) == 0 || $annee_comptable($laq) < 1970} {
	set jour_comptable($laq) 0
	set mois_comptable($laq) 0
	set annee_comptable($laq) 0
	return ""
    }
    # verif
    if {$jour_comptable($laq) > $mois_jour($mois_comptable($laq))} {
	if {$mois_comptable($laq)==2 && [bissex $annee_comptable($laq)]==1} {
	    set jour_comptable($laq) 29
	} else {set jour_comptable($laq) $mois_jour($mois_comptable($laq))}
    }
    if {$jour_comptable($laq) < 10} {
	set jour "0$jour_comptable($laq)"} else {set jour $jour_comptable($laq)}
    if {$mois_comptable($laq) < 10} {
	set mois "0$mois_comptable($laq)"} else {set mois $mois_comptable($laq)
    }
    return "${jour}-${mois}-$annee_comptable($laq)"
}

proc date_pos2aff {date} {
    return $date
}
# pour compter avec, on retourne anneemoisjour, on part d'un format jour-mois-an car 
# on est en francais pour afficher les dates
proc date2compte {date} {
    global mois_nbrjt

    set date_l [split $date -]
    # format jour-mois-anne
    set jour [lindex $date_l 0]
    set mois [lindex $date_l 1]
    set annee_comptable [lindex $date_l 2]
    # probleme avec l'octal
    if {[string index $jour 0] == "0"} {
	set jour_comptable [string index $jour 1]
    } else {set jour_comptable $jour}
    if {[string index $mois 0] == "0"} {
	set mois_comptable [string index $mois 1]
    } else {set mois_comptable $mois}
    return [expr $annee_comptable*365 + [nbr_bissex $annee_comptable] + $mois_nbrjt($mois_comptable,[bissex $annee_comptable]) + $jour_comptable]
}

# renvoie le nbr de jours en plus dus aux annes bissex depuis 1970
proc nbr_bissex {an} {
    set n 0
    for {set i 1970} {$i < $an} {incr i} {
	if [bissex $i] {incr n}
    }
    return $n
}

# decoupe une date qui est en version fr
proc decoupe_date_fr {laq} {
    decoupe_date $laq
}

